#include <stdbool.h>

#include "protocol.h"

#define MAX_PLAYERS 32
#define MAX_BULLETS (MAX_PLAYERS * 8)
#define TICK_DELAY  (1000 / 30)
#define BULLET_TIME (TICK_DELAY * 6)
#define PLAYER_SIZE 0.01785

typedef struct Player {
	/* public */
	bool  live;
	float x, y, r;
	float vx, vy, vr;

	/* internal */
	bool  updated;
} Player;

typedef struct Bullet {
	/* public */
	bool  live;
	int   owner;
	float x, y;
	float vx, vy;
	int   tick;

	/* internal */
	bool updated;
} Bullet;

extern Player g_player[MAX_PLAYERS];
extern Bullet g_bullet[MAX_BULLETS];

void g_player_set(unsigned int id, bool live, float x, float y, float r, float vx, float vy, float vr);
void g_bullet_set(unsigned int id, unsigned int owner, bool live, float x, float y, float vx, float vy, int tick);
void g_player_does(unsigned int id, DoesCode code);
void g_update();
